#include<windows.h>

#define ERROR_SUCCESS 0
#define ERROR_FATAL 1
#define ERROR_NONFATAL 2

typedef struct _PEC_DATA_BLOCK_INFO
{
       PVOID pBlockRVA;
       ULONG nCompressedSize; 
} PEC_DATA_BLOCK_INFO, *PPEC_DATA_BLOCK_INFO;        

DWORD PreOperativePluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize,
                LPVOID pImageBase,
                PPEC_DATA_BLOCK_INFO pDataBlockInfoArray);

DWORD PostOperativePluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize);

DWORD InitEncryptionPluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize,
                HINSTANCE hInstance,
                LPVOID pUserData,
                DWORD nUserDataLen);
                                
DWORD DecryptPluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize,
				LPVOID pSource,
				DWORD nDataSize,
				LPVOID pDestination);

DWORD EncryptPluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize,
				LPVOID pSource,
				DWORD nDataSize,
				LPVOID pDestination);

DWORD GetProcAddressHookPluginV2(HMODULE pLoadLibrary,
                LPVOID pGetProcAddress,
                LPVOID pResidentData,
                DWORD nResidentDataSize,
                HMODULE hModule,
                LPSTR pszApiName);

